



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Unity5 AssetBundle系列——简单的AssetBundleManager</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Unity5 AssetBundle系列——简单的AssetBundleManager</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 10:08:21 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　一个AssetBundle同时只能加载一次，所以实际使用中一般会伴随着AssetBundle包的管理。</p>
<p>　　下面是一个简单的AssetBundle管理器，提供了同步和异步加载函数：</p>
<div>
<pre class="prettyprint linenums">using UnityEngine;<br />
using System.Collections;<br />
using System.Collections.Generic;

public class AssetBundleManager<br />
{<br />
    public static AssetBundleManager Instace<br />
    {<br />
        get<br />
        {<br />
            if (_instace == null) _instace = new AssetBundleManager();<br />
            return _instace;<br />
        }<br />
    }<br />
    private static AssetBundleManager _instace = null;

    private AssetBundleManifest manifest = null;<br />
    private Dictionary&lt;string, AssetBundle&gt; dicAssetBundle = new Dictionary&lt;string, AssetBundle&gt;();

    // filename : Assets全路径，比如Assets/Prefab/***.prefab<br />
    public AssetBundle GetAssetBundle(string filePath)<br />
    {<br />
        AssetBundle ab = null;<br />
        dicAssetBundle.TryGetValue(AssetsNameToBundleName(filePath), out ab);<br />
        return ab;<br />
    }

    // 加载manifest，用来处理关联资源<br />
    public void LoadManifest()<br />
    {<br />
        AssetBundle bundle = AssetBundle.LoadFromFile(MainifestFilePath());<br />
        manifest = bundle.LoadAsset&lt;AssetBundleManifest&gt;("AssetBundleManifest");<br />
        // 压缩包直接释放掉<br />
        bundle.Unload(false);<br />
        bundle = null;<br />
    }

    // filename : Assets全路径，比如Assets/Prefab/***.prefab<br />
    public AssetBundle Load(string filename)<br />
    {<br />
        string bundleName = AssetsNameToBundleName(filename);<br />
        if (dicAssetBundle.ContainsKey(bundleName))<br />
        {<br />
            return dicAssetBundle[bundleName];<br />
        }

        string[] dependence = manifest.GetAllDependencies(bundleName);<br />
        for (int i = ; i &lt; dependence.Length; ++i)<br />
        {<br />
            LoadInternal(dependence[i]);<br />
        }

        return LoadInternal(bundleName);<br />
    }

    // filename : Assets全路径，比如Assets/Prefab/***.prefab<br />
    public IEnumerator LoadAsync(string filename)<br />
    {<br />
        string bundleName = AssetsNameToBundleName(filename);<br />
        if (dicAssetBundle.ContainsKey(bundleName))<br />
        {<br />
            yield break;<br />
        }

        string[] dependence = manifest.GetAllDependencies(bundleName);<br />
        for (int i = ; i &lt; dependence.Length; ++i)<br />
        {<br />
            yield return LoadInternalAsync(dependence[i]);<br />
        }

        yield return LoadInternalAsync(bundleName);<br />
    }

    public void Unload(string filename, bool force = false)<br />
    {<br />
        string bundleName = AssetsNameToBundleName(filename);

        AssetBundle ab = null;<br />
        if (dicAssetBundle.TryGetValue(bundleName, out ab) == false) return;

        if (ab == null) return;

        ab.Unload(force);<br />
        ab = null;<br />
        dicAssetBundle.Remove(bundleName);<br />
    }

    public void UnloadUnusedAssets()<br />
    {<br />
        Resources.UnloadUnusedAssets();<br />
        System.GC.Collect();<br />
    }

    public void Release()<br />
    {<br />
        foreach(var pair in dicAssetBundle)<br />
        {<br />
            var bundle = pair.Value;<br />
            if(bundle != null)<br />
            {<br />
                bundle.Unload(true);<br />
                bundle = null;<br />
            }<br />
        }<br />
        dicAssetBundle.Clear();<br />
    }

    private AssetBundle LoadInternal(string bundleName)<br />
    {<br />
        if (dicAssetBundle.ContainsKey(bundleName))<br />
        {<br />
            return dicAssetBundle[bundleName];<br />
        }

        AssetBundle bundle = AssetBundle.LoadFromFile(BundleNameToBundlePath(bundleName));<br />
        dicAssetBundle.Add(bundleName, bundle);<br />
        return bundle;<br />
    }

    private IEnumerator LoadInternalAsync(string bundleName)<br />
    {<br />
        if (dicAssetBundle.ContainsKey(bundleName))<br />
        {<br />
            yield break;<br />
        }

        AssetBundleCreateRequest req = AssetBundle.LoadFromFileAsync(BundleNameToBundlePath(bundleName));<br />
        yield return req;

        dicAssetBundle.Add(bundleName, req.assetBundle);<br />
    }

    // 名字依赖于存放目录<br />
    private string MainifestFilePath()<br />
    {<br />
        return Application.dataPath + "/StreamingAssets/StreamingAssets";<br />
    }

    // Assets/Prefab/***.prefab --&gt; assets.prefab.***.prefab.assetbundle<br />
    private string AssetsNameToBundleName(string file)<br />
    {<br />
        string f = file.Replace('/', '.');<br />
        f = f.ToLower();<br />
        f += ".assetbundle";<br />
        return f;<br />
    }

    // assets.prefab.***.prefab.assetbundle --&gt; C:/***path***/assets.prefab.***.prefab.assetbundle<br />
    private string BundleNameToBundlePath(string bundleFilename)<br />
    {<br />
        return System.IO.Path.Combine(Application.dataPath + "/StreamingAssets/", bundleFilename);<br />
    }

}</pre>
</div>
<p>　　当然bundle也可以通过WWW或其他的方式来加载，这一块Unity5到没有什么变化，具体使用方式可以参考我以前的博客。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqloyy1q.html">mpstat命令学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7n2me9.html">android-studio-bundle-141&period;1980579-windows download Site</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvr61o8.html">flash builder &lpar;fb&rpar; 与flash professional cs6&lpar;fla&rpar; 联合调试</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mz43rq.html">python 培训之HTTP</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdvdwzq.html">Java碎片知识（笔记）</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96v3548.html">Ext&period;NET 4&period;1&period;0 GridPanel数据分页</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w4ko3q.html">切割 bitmap</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnvm4d8.html">css 单位 px em rem</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vojz38.html">iOS设计模式解析（四）组合模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k133v59.html">Spring Boot使用Druid和监控配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv11xjoq.html">dapper的Dapper-Extensions用法（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgny0m8.html">centos搭建svn服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzv3408.html">TCP&sol;IP（五）传输层（TCP的三次握手和四次挥手）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg6xxe8.html">Python 编程基础之高阶函数篇&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zjz5g9.html">Cs Round&num;56 D Find Path Union</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1omejq.html">&lbrack;转&rsqb;OpenLiveWriter 代码插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gevpp78.html">Android For JNI&lpar;四&rpar;&mdash;&mdash;C的数组，指针长度，堆内存和栈内存，malloc，学生管理系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yejvw8.html">Python爬虫入门教程 7-100 蜂鸟网图片爬取之二</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjmgy59.html">MySQL 练习题 附答案，未完</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdzrkz9.html">java对PDF文档的各种操作</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q25ex2vq.html">java 同步 synchronized</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25exeoq.html">Windows 修改host文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2pdmx9.html">打开Word时出现&OpenCurlyDoubleQuote;The setup controller has encountered a problem during install&period; Please &period;&period;&period;&rdquo;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnv6y228.html">CSDN博客文章的备份及导出电子书CHM</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvpwwy8.html">喵哈哈村的魔法考试 Round &num;8 &lpar;Div&period;2&rpar; 题解</a>
			</li>
						<li><a href="https://www.batexi.com/a/9602zdj9.html">Reveal：分析iOS UI的利器</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj6xm49.html">Kubernetes基础：编排调度的那些Controllers</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e46xzm9.html">Art&colon; Neural Style Transfer</a>
			</li>
						<li><a href="https://www.batexi.com/a/96022p49.html">PL&sol;SQL学习笔记之条件控制语句</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1roxv68.html">关于input时间框设置了弹出选择就不能手动输入的控制</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
